VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsVolume"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*******************************************************************************
' ++++++++ Klassenmodul fr die Lautstrkeeinstellung mit Visual Basic +++++++++
' +++ Die Komponenten: Gesamtlautstrke, Mikrofon, WaveIn, LineIn, CD-Audio  +++
' + Ursprnglicher Autor: Unbekannt. Modifiziert und erweitert von J. Thmmler +
'*******************************************************************************
Option Explicit
'*******************************************************************************
Private Const MMSYSERR_NOERROR = 0
Private Const MAXPNAMELEN = 32
Private Const MIXER_LONG_NAME_CHARS = 64
Private Const MIXER_SHORT_NAME_CHARS = 16
Private Const MIXER_GETLINEINFOF_COMPONENTTYPE = &H3&
Private Const MIXER_GETCONTROLDETAILSF_VALUE = &H0&
Private Const MIXER_GETCONTROLDETAILSF_LISTTEXT& = &H1&
Private Const MIXER_GETLINECONTROLSF_ONEBYTYPE = &H2&
Private Const MIXER_OBJECTF_WAVEOUT& = &H10000000
Private Const MIXER_SETCONTROLDETAILSF_VALUE = &H0&
Private Const MIXERCONTROL_CT_CLASS_FADER = &H50000000
Private Const MIXERCONTROL_CT_UNITS_UNSIGNED = &H30000
Private Const MIXERCONTROL_CONTROLTYPE_FADER = (MIXERCONTROL_CT_CLASS_FADER Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_VOLUME = (MIXERCONTROL_CONTROLTYPE_FADER + 1)
'--------------------------------------------------------------------------------
Private Const MIXERLINE_COMPONENTTYPE_SRC_FIRST = &H1000&
Private Const MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0)
Private Const MIXERLINE_COMPONENTTYPE_SRC_DIGITAL = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1)
Private Const MIXERLINE_COMPONENTTYPE_SRC_LINE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2)
Private Const MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3)
Private Const MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5)
Private Const MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6)
Private Const MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7)
Private Const MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8)
Private Const MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9)
Private Const MIXERLINE_COMPONENTTYPE_SRC_ANALOG = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)
Private Const MIXERLINE_COMPONENTTYPE_SRC_LAST = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10)

Private Const MIXERLINE_COMPONENTTYPE_DST_FIRST& = &H0&
Private Const MIXERLINE_COMPONENTTYPE_DST_UNDEFINED = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 0)
Private Const MIXERLINE_COMPONENTTYPE_DST_DIGITAL = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 1)
Private Const MIXERLINE_COMPONENTTYPE_DST_LINE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 2)
Private Const MIXERLINE_COMPONENTTYPE_DST_MONITOR = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 3)
Private Const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_DST_HEADPHONES = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 5)
Private Const MIXERLINE_COMPONENTTYPE_DST_TELEPHONE = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 6)
Private Const MIXERLINE_COMPONENTTYPE_DST_WAVEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 7)
Private Const MIXERLINE_COMPONENTTYPE_DST_VOICEIN = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
Private Const MIXERLINE_COMPONENTTYPE_DST_LAST = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 8)
'********************************************************************************
Private Type MIXERCAPS
    wMid As Integer                   '  manufacturer id
    wPid As Integer                   '  product id
    vDriverVersion As Long            '  version of the driver
    szPname As String * MAXPNAMELEN   '  product name
    fdwSupport As Long                '  misc. support bits
    cDestinations As Long             '  count of destinations
End Type
'--------------------------------------------------------------------------------
Private Type MIXERCONTROL
    cbStruct As Long                  '  size in Byte of MIXERCONTROL
    dwControlID As Long               '  unique control id for mixer device
    dwControlType As Long             '  MIXERCONTROL_CONTROLTYPE_xxx
    fdwControl As Long                '  MIXERCONTROL_CONTROLF_xxx
    cMultipleItems As Long            '  if MIXERCONTROL_CONTROLF_MULTIPLE set
    szShortName As String * MIXER_SHORT_NAME_CHARS  ' short name of control
    szName As String * MIXER_LONG_NAME_CHARS        ' long name of control
    lMinimum As Long                  '  Minimum value
    lMaximum As Long                  '  Maximum value
    reserved(10) As Long              '  reserved structure space
End Type
'--------------------------------------------------------------------------------
Private Type MIXERCONTROLDETAILS
    cbStruct As Long                  '  size in Byte of MIXERCONTROLDETAILS
    dwControlID As Long               '  control id to get/set details on
    cChannels As Long                 '  number of channels in paDetails array
    item As Long                      '  hwndOwner or cMultipleItems
    cbDetails As Long                 '  size of _one_ details_XX struct
    paDetails As Long                 '  pointer to array of details_XX structs
End Type
'--------------------------------------------------------------------------------
Private Type MIXERCONTROLDETAILS_UNSIGNED
    dwValue As Long                   '  value of the control
End Type
'--------------------------------------------------------------------------------
Private Type MIXERLINE
    cbStruct As Long                  '  size of MIXERLINE structure
    dwDestination As Long             '  zero based destination index
    dwSource As Long                  '  zero based source index (if source)
    dwLineID As Long                  '  unique line id for mixer device
    fdwLine As Long                   '  state/information about line
    dwUser As Long                    '  driver specific information
    dwComponentType As Long           '  component Private Type line connects to
    cChannels As Long                 '  number of channels line supports
    cConnections As Long              '  number of connections (possible)
    cControls As Long                 '  number of controls at this line
    szShortName As String * MIXER_SHORT_NAME_CHARS
    szName As String * MIXER_LONG_NAME_CHARS
    dwType As Long
    dwDeviceID As Long
    wMid  As Integer
    wPid As Integer
    vDriverVersion As Long
    szPname As String * MAXPNAMELEN
End Type
'--------------------------------------------------------------------------------
Private Type MIXERLINECONTROLS
    cbStruct As Long                  '  size in Byte of MIXERLINECONTROLS
    dwLineID As Long                  '  line id (from MIXERLINE.dwLineID)
                                      '  MIXER_GETLINECONTROLSF_ONEBYID or
    dwControl As Long                 '  MIXER_GETLINECONTROLSF_ONEBYTYPE
    cControls As Long                 '  count of controls pamxctrl points to
    cbmxctrl As Long                  '  size in Byte of _one_ MIXERCONTROL
    pamxctrl As Long                  '  pointer to first MIXERCONTROL array
End Type
'********************************************************************************
Private Declare Function mixerClose& Lib "winmm.dll" (ByVal hmx&)
Private Declare Function mixerGetControlDetails& Lib "winmm.dll" Alias "mixerGetControlDetailsA" _
               (ByVal hmxobj&, pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails&)
Private Declare Function mixerGetDevCaps& Lib "winmm.dll" Alias "mixerGetDevCapsA" (ByVal uMxId&, _
                ByVal pmxcaps As MIXERCAPS, ByVal cbmxcaps&)
Private Declare Function mixerGetID& Lib "winmm.dll" (ByVal hmxobj&, pumxID&, ByVal fdwId&)
Private Declare Function mixerGetLineControls& Lib "winmm.dll" Alias "mixerGetLineControlsA" _
               (ByVal hmxobj&, pmxlc As MIXERLINECONTROLS, ByVal fdwControls&)
Private Declare Function mixerGetLineInfo& Lib "winmm.dll" Alias "mixerGetLineInfoA" _
               (ByVal hmxobj&, pmxl As MIXERLINE, ByVal fdwInfo&)
Private Declare Function mixerGetNumDevs& Lib "winmm.dll" ()
Private Declare Function mixerMessage& Lib "winmm.dll" (ByVal hmx&, ByVal uMsg&, _
                ByVal dwParam1&, ByVal dwParam2&)
Private Declare Function mixerOpen& Lib "winmm.dll" (phmx&, ByVal uMxId&, _
                ByVal dwCallback&, ByVal dwInstance&, ByVal fdwOpen&)
Private Declare Function mixerSetControlDetails& Lib "winmm.dll" (ByVal hmxobj&, _
                pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails&)
Private Declare Sub CopyStructFromPtr Lib "kernel32" Alias "RtlMoveMemory" _
               (struct As Any, ByVal ptr&, ByVal cb&)
Private Declare Sub CopyPtrFromStruct Lib "kernel32" Alias "RtlMoveMemory" _
               (ByVal ptr&, struct As Any, ByVal cb&)
Private Declare Function GlobalAlloc& Lib "kernel32" (ByVal wFlags&, ByVal dwBytes&)
Private Declare Function GlobalLock& Lib "kernel32" (ByVal hmem&)
Private Declare Function GlobalFree& Lib "kernel32" (ByVal hmem&)
'********************************************************************************
Dim hMixer&                           ' mixer handle
Dim volCtrl As MIXERCONTROL           ' waveout volume control
Dim micCtrl As MIXERCONTROL           ' microphone volume control
Dim wavCtrl As MIXERCONTROL           ' wave-in volume control
Dim linCtrl As MIXERCONTROL           ' line-in volume control
Dim cd_Ctrl As MIXERCONTROL           ' audio-cd volume control
Dim midCtrl As MIXERCONTROL           ' midi volume control

Dim MinVolVol&, MaxVolVol&            ' Min/Maxwerte fr VolControl
Dim MinMicVol&, MaxMicVol&            ' Min/Maxwerte fr MicroControl
Dim MinWavVol&, MaxWavVol&            ' Min/Maxwerte fr WaveControl
Dim MinLinVol&, MaxLinVol&            ' Min/Maxwerte fr LineControl
Dim MinCD_Vol&, MaxCD_Vol&            ' Min/Maxwerte fr LineControl
Dim MinMidVol&, MaxMidVol&            ' Min/Maxwerte fr Midi

Dim mxl As MIXERLINE
Dim mxc As MIXERCONTROL
Dim mxcd As MIXERCONTROLDETAILS
Dim mxlc As MIXERLINECONTROLS
Dim Vol As MIXERCONTROLDETAILS_UNSIGNED

Dim bOK As Boolean                    ' boolean return code
Dim hmem&                             ' Memory handle
Dim rc&                               ' return code
'********************************************************************************
'********************************************************************************
'# Hier folgt die "Schnittstelle" des Klassenmoduls nach auen
'********************************************************************************
Public Property Get MinWaveVolume&()          '# Minimalwert der Gesamtlautstrke
  MinWaveVolume = MinVolVol
End Property

'********************************************************************************
Public Property Get MaxWaveVolume&()          '# Maximalwert der Gesamtlautstrke
  MaxWaveVolume = MaxVolVol
End Property

'********************************************************************************
Public Property Get MinMicVolume&()           '# Minimalwert der Mikrolautstrke
  MinMicVolume = MinMicVol
End Property

'********************************************************************************
Public Property Get MaxMicVolume&()           '# Maximalwert der Mikrolautstrke
  MaxMicVolume = MaxMicVol
End Property

'********************************************************************************
Public Property Get MinWavInVolume&()         '# Minimalwert der WaveInlautstrke
  MinWavInVolume = MinWavVol
End Property

'********************************************************************************
Public Property Get MaxWavInVolume&()         '# Maximalwert der WaveInlautstrke
  MaxWavInVolume = MaxWavVol
End Property

'********************************************************************************
Public Property Get MinMidVolume&()         '# Minimalwert der Midilautstrke
  MinMidVolume = MinMidVol
End Property

'********************************************************************************
Public Property Get MaxMidVolume&()         '# Maximalwert der Midilautstrke
  MaxMidVolume = MaxMidVol
End Property

'********************************************************************************
Public Property Get MinLineInVolume&()        '# Minimalwert der LineInlautstrke
  MinLineInVolume = MinLinVol
End Property

'********************************************************************************
Public Property Get MaxLineInVolume&()        '# Maximalwert der LineInlautstrke
  MaxLineInVolume = MaxLinVol
End Property

'********************************************************************************
Public Property Get MinCDVolume&()            '# Minimalwert der CD-Lautstrke
  MinCDVolume = MinCD_Vol
End Property

'********************************************************************************
Public Property Get MaxCDVolume&()            '# Maximalwert der CD-Lautstrke
  MaxCDVolume = MaxCD_Vol
End Property

'********************************************************************************
Public Property Get WaveVolume&()             '# Aktuelle Gesamtlautstrke
  WaveVolume = GetVolume(volCtrl)
End Property

'********************************************************************************
Public Property Get MicroVolume&()            '# Aktuelle Mikrofonlautstrke
  MicroVolume = GetVolume(micCtrl)
End Property

'********************************************************************************
Public Property Get WaveInVolume&()           '# Aktuelle WaveInlautstrke
  WaveInVolume = GetVolume(wavCtrl)
End Property

'********************************************************************************
Public Property Get MidVolume&()           '# Aktuelle Midilautstrke
  MidVolume = GetVolume(midCtrl)
End Property

'********************************************************************************
Public Property Get LineInVolume&()           '# Aktuelle LineInlautstrke
  LineInVolume = GetVolume(linCtrl)
End Property

'********************************************************************************
Public Property Get CD_Volume&()              '# Aktuelle CD-Lautstrke
  CD_Volume = GetVolume(cd_Ctrl)
End Property

'********************************************************************************
Public Property Let WaveVolume(ByVal NewVolume&)  '# Einstellung Gesamtlautstrke
  If NewVolume < MinVolVol Then NewVolume = MinVolVol
  If NewVolume > MaxVolVol Then NewVolume = MaxVolVol
  Call SetVolume(volCtrl, NewVolume)
End Property

'********************************************************************************
Public Property Let MicroVolume(ByVal NewVolume&) '# Einstellung Mikro-Lautstrke
  If NewVolume < MinMicVol Then NewVolume = MinMicVol
  If NewVolume > MaxMicVol Then NewVolume = MaxMicVol
  Call SetVolume(micCtrl, NewVolume)
End Property

'********************************************************************************
Public Property Let WaveInVolume(ByVal NewVolume&) '# Einstellung Wave-Lautstrke
  If NewVolume < MinWavVol Then NewVolume = MinWavVol
  If NewVolume > MaxWavVol Then NewVolume = MaxWavVol
  Call SetVolume(wavCtrl, NewVolume)
End Property

'********************************************************************************
Public Property Let MidVolume(ByVal NewVolume&) '# Einstellung Midi-Lautstrke
  If NewVolume < MinMidVol Then NewVolume = MinMidVol
  If NewVolume > MaxMidVol Then NewVolume = MaxMidVol
  Call SetVolume(midCtrl, NewVolume)
End Property

'********************************************************************************
Public Property Let LineInVolume(ByVal NewVolume&) '# Einstellung Line-Lautstrke
  If NewVolume < MinLinVol Then NewVolume = MinLinVol
  If NewVolume > MaxLinVol Then NewVolume = MaxLinVol
  Call SetVolume(linCtrl, NewVolume)
End Property

'********************************************************************************
Public Property Let CD_Volume(ByVal NewVolume&)    '# Einstellung CD-Lautstrke
  If NewVolume < MinCD_Vol Then NewVolume = MinCD_Vol
  If NewVolume > MaxCD_Vol Then NewVolume = MaxCD_Vol
  Call SetVolume(cd_Ctrl, NewVolume)
End Property

'********************************************************************************
'********************************************************************************
'# Hier werden die Grundparameter abgefragt bzw. gesetzt

Private Sub Class_Initialize()
  '---------------------------------------------------------------------
  '# Open the mixer with deviceID 0.
  rc = mixerOpen(hMixer, 0, 0, 0, 0)
  If rc <> MMSYSERR_NOERROR Then
    MsgBox "Es wurde kein Mixer in Ihrem System gefunden !"
    Exit Sub
  End If
  '---------------------------------------------------------------------
  '# Get the waveout volume control  (Gesamtlautstrke)
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_DST_SPEAKERS, volCtrl)
  
  If bOK Then
    ' If the Function successfully gets the volume control, the maximum
    ' and minimum values are specified by lMaximum and lMinimum
    With volCtrl
      MinVolVol = .lMinimum
      MaxVolVol = .lMaximum
    End With
  End If
  '---------------------------------------------------------------------
  '# Get the microphone volume control
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE, micCtrl)
  
  If bOK Then
    With micCtrl
      MinMicVol = .lMinimum
      MaxMicVol = .lMaximum
    End With
  End If
  '---------------------------------------------------------------------
  '# Get the wave-in volume control
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT, wavCtrl)
  
  If bOK Then
    With wavCtrl
      MinWavVol = .lMinimum
      MaxWavVol = .lMaximum
    End With
  End If
  '---------------------------------------------------------------------
  '# Get the midi volume control
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER, midCtrl)
  
  If bOK Then
    With midCtrl
      MinMidVol = .lMinimum
      MaxMidVol = .lMaximum
    End With
  End If
  '---------------------------------------------------------------------
  '# Get the CD audio volume control
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC, cd_Ctrl)
  
  If bOK Then
    With cd_Ctrl
      MinCD_Vol = .lMinimum
      MaxCD_Vol = .lMaximum
    End With
  End If
  '---------------------------------------------------------------------
  '# Get the line-in volume control
  bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_LINE, linCtrl)
  
  If bOK Then
    With linCtrl
      MinLinVol = .lMinimum
      MaxLinVol = .lMaximum
    End With
  Else  '# Some manufacturer use this type of device for line-in
    bOK = GetVolumeControl(hMixer, MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY, linCtrl)
    If bOK Then
      With linCtrl
        MinLinVol = .lMinimum
        MaxLinVol = .lMaximum
      End With
    End If
  End If
  '---------------------------------------------------------------------
  '# In the same way may be opened other devices;
  '# for possible types refer to the constants
  '# MIXERLINE_COMPONENTTYPE_SRC_XXX and
  '# MIXERLINE_COMPONENTTYPE_DST_XXX
  '---------------------------------------------------------------------
End Sub

'********************************************************************************
'# This Function attempts to obtain a mixer control. Returns True if successful.

Private Function GetVolumeControl(ByVal hMixer&, ByVal componentType&, _
                                  mxc As MIXERCONTROL) As Boolean

Const ctrlType& = MIXERCONTROL_CONTROLTYPE_VOLUME '# Nur Laustrkeregler suchen
  
  mxl.cbStruct = Len(mxl)
  mxl.dwComponentType = componentType
  
  ' Obtain a line corresponding to the component Private Type
  rc = mixerGetLineInfo(hMixer, mxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
  
  If (MMSYSERR_NOERROR = rc) Then
    With mxlc
      .cbStruct = Len(mxlc)
      .dwLineID = mxl.dwLineID
      .dwControl = ctrlType
      .cControls = 1
      .cbmxctrl = Len(mxc)
      
      ' Allocate a buffer for the control
      hmem = GlobalAlloc(&H40, Len(mxc))
      .pamxctrl = GlobalLock(hmem)
      mxc.cbStruct = Len(mxc)
    End With
    
    ' Get the control
    rc = mixerGetLineControls(hMixer, mxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
    
    If (MMSYSERR_NOERROR = rc) Then
      GetVolumeControl = True
      ' Copy the control into the destination structure
      CopyStructFromPtr mxc, mxlc.pamxctrl, Len(mxc)
    Else
      GetVolumeControl = False
    End If
    
    Call GlobalFree(hmem)
    Exit Function
  End If
  
  GetVolumeControl = False
End Function

'********************************************************************************
'# This Function sets the value for a volume control. Returns True if successful

Private Function SetVolume(mxctl As MIXERCONTROL, ByVal volume&) As Boolean
                         
    mxc = mxctl
    Call PrepareStruct
    
    ' Copy the data into the control value buffer
    Vol.dwValue = volume
    CopyPtrFromStruct mxcd.paDetails, Vol, Len(Vol)
    
    ' Set the control value
    rc = mixerSetControlDetails(hMixer, mxcd, MIXER_SETCONTROLDETAILSF_VALUE)
    GlobalFree (hmem)
    
    If (rc = MMSYSERR_NOERROR) Then
      SetVolume = True
    Else
      SetVolume = False
    End If
End Function

'********************************************************************************
'# Diese Funktion gibt den aktuell eingestellten Volume-Wert
'# fr das an die Funktion bergebene MixerControl zurck
'# This function returns the current value of the passed mixercontrol

Private Function GetVolume&(mxctl As MIXERCONTROL)
    
  mxc = mxctl
  Call PrepareStruct
  
  ' Get the control value
  rc = mixerGetControlDetails(hMixer, mxcd, MIXER_GETCONTROLDETAILSF_VALUE)
  
  ' Copy the data from control value buffer
  CopyStructFromPtr Vol, mxcd.paDetails, Len(Vol)
  Call GlobalFree(hmem)
  
  If (rc = MMSYSERR_NOERROR) Then
    GetVolume = Vol.dwValue '# Aktuell eingestellter Wert
  Else
    GetVolume = 0
  End If
End Function

'********************************************************************************
Private Sub PrepareStruct() '# Initialisieren der MIXERCONTROLDETAILS-Struktur

Vol.dwValue = 0
With mxcd
  .item = 0
  .dwControlID = mxc.dwControlID
  .cbStruct = Len(mxcd)
  .cbDetails = Len(Vol)
  ' Allocate a buffer for the control value buffer
  hmem = GlobalAlloc(&H40, Len(Vol))
  .paDetails = GlobalLock(hmem)
  .cChannels = 1
End With
End Sub

'********************************************************************************
Private Sub Class_Terminate()
Call mixerClose(hMixer)
End Sub

'********************************************************************************

